/************************************************************************/
/* Compiler.h: The SpecC Compiler					*/
/************************************************************************/
/* Author: Rainer Doemer			first version: 08/31/97 */
/************************************************************************/

/* last update: 11/13/01 */

/* modifications: (most recent first)
 *
 * 11/13/01 RD	added command line options for code generation parameters
 * 11/13/01 RD	introduced this header (last update was 04/26/99)
 */

#ifndef COMPILER_H
#define COMPILER_H


#include "Global.h"


/*** constants and macros ***********************************************/


	/* flag for DEBUG mode */
// #define SCC_DEBUG


	/* error codes for this module */
#define SCC_ERROR_NO_ERROR			(NO_ERROR)
#define SCC_ERROR_NO_DESIGN_NAME		(SCC_ERROR_BASE +  1)
#define SCC_ERROR_UNKNOWN_COMMAND		(SCC_ERROR_BASE +  2)
#define SCC_ERROR_BAD_DESIGN_NAME		(SCC_ERROR_BASE +  3)
#define SCC_ERROR_BAD_ARGUMENT			(SCC_ERROR_BASE +  4)
#define SCC_ERROR_UNKNOWN_OPTION		(SCC_ERROR_BASE +  5)
#define SCC_ERROR_OPTION_NEEDS_ARGUMENT		(SCC_ERROR_BASE +  6)
#define SCC_ERROR_EMPTY_ARGUMENT		(SCC_ERROR_BASE +  7)
#define SCC_ERROR_OUTPUT_FILENAME_AMBIGUOUS	(SCC_ERROR_BASE +  8)
#define SCC_ERROR_OPTION_IO_REQUIRED		(SCC_ERROR_BASE +  9)
#define SCC_ERROR_INVALID_VALUE_FOR_OPTION	(SCC_ERROR_BASE + 10)


/*** type definitions ***************************************************/


	/* none */


/*** exported variables *************************************************/


	/* none */


/************************************************************************/
/*** prototype definitions for exported functions		      ***/
/************************************************************************/


	/* none */


#endif /* COMPILER_H */

/* EOF Compiler.h */
