// try23.sc

#include <sim.sh>

#include <stdio.h>
#include <assert.h>

behavior Try(out event e)
{
	void main(void)
	{
	waitfor 2;
	notify e;
	waitfor 2;
	notify e;
	waitfor 2;
	notify e;
	waitfor 2;
	notify e;
	waitfor 2;
	}
};

behavior TrapA(inout int x)
{
	void main(void)
	{
	x++;
	}
};

behavior TrapB(inout int y)
{
	void main(void)
	{
	y++;
	}
};

behavior InterruptA(inout int x)
{
	void main(void)
	{
	x++;
	}
};

behavior InterruptB(inout int y)
{
	void main(void)
	{
	y++;
	}
};

behavior Exception(inout int x, inout int y,
		inout event e1, in event e2, in event e3, in event e4)
{
	Try		t(e1);
	TrapA		ta(x);
	TrapB		tb(y);
	InterruptA	ia(x);
	InterruptB	ib(y);

	void main(void)
	{
	try {	t.main();
		}
		trap e1
		    {	ta.main();
			}
		trap e2
		    {	tb.main();
			}
		interrupt e3
		    {	ia.main();
			}
		interrupt e4
		    {	ib.main();
			};
	}
};

behavior Trigger(out event e)
{
	void main(void)
	{
	waitfor 5;
	notify e;
	waitfor 1;
	}
};

behavior Main
{
	event		e1, e2, e3, e4, e5;
	int		x = 0;
	int		y = 0;

	Exception	e(x, y, e1, e2, e3, e4);
	Trigger		t1(e1),
			t2(e2),
			t3(e3),
			t4(e4),
			t5(e5);

	int main(void)
	{
	puts("try23: Starting...");

	par {	e.main();
		t1.main();
		}
	assert(x == 1);
	assert(y == 0);
	assert(now() == 6);

	par {	e.main();
		t2.main();
		}
	assert(x == 2);
	assert(y == 0);
	assert(now() == 12);

	par {	e.main();
		t5.main();
		}
	assert(x == 3);
	assert(y == 0);
	assert(now() == 18);

	puts("try23: Done.");
	return(0);
	}
};

// EOF
